//////////////////////////////////////////////////////////////////////////////////////
/*
Author: Henrik Krysell
E-mail: drx@drx.dk
Website: www.drx.dk

Copyright (C) 2004  Henrik Krysell

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
//////////////////////////////////////////////////////////////////////////////////////

/*
	FIXME!
	There are a lot of things to optimize in this class ex:

	* add more methods, and suport for all kinds of box collision
*/

package starship2d;

public class BoundingBox2
{
	public Vector2 top = new Vector2(0,0);
	public Vector2 bottom = new Vector2(0,0);
	
	public BoundingBox2()
	{
	}
	
	public BoundingBox2(Vector2 pos, Vector2 size)
	{
		top = new Vector2(pos);
		bottom = new Vector2(pos.x + size.x, pos.y + size.y);
	}
	
	public void translate(Vector2 trans)
	{
		top.x += trans.x;
		top.y += trans.y;
		bottom.x += trans.x;
		bottom.y += trans.y;
	}
	
	public boolean boxInBox(BoundingBox2 bb)
	{
		return boxInBox(bb, true);
	}
	
	public boolean boxInBox(BoundingBox2 bb, boolean recurse)
	{
		boolean res = pointInBox(bb.top) || pointInBox(bb.bottom) || pointInBox(new Vector2(bb.top.x, bb.bottom.y)) 
				|| pointInBox(new Vector2(bb.bottom.x, bb.top.y));
		
		if (!res && recurse)
			res = bb.boxInBox(this, false);
			
		return res;
	}
	
	public boolean pointInBox(Vector2 p)
	{
		return (p.x > top.x) && (p.x < bottom.x) && (p.y > top.y) && (p.y < bottom.y);
	}
	
	public String toString()
	{
		return "[" + top + ", " + bottom + "]";
	}
} // end BoundingBox2
