//////////////////////////////////////////////////////////////////////////////////////
/*
Author: Henrik Krysell
E-mail: drx@drx.dk
Website: www.drx.dk

Copyright (C) 2004  Henrik Krysell

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
//////////////////////////////////////////////////////////////////////////////////////

/*
	FIXME!
	There are a lot of things to optimize in this class ex:

	* go through this class and look for optimaztions
*/

package starship2d;

import org.lwjgl.Display;
import org.lwjgl.DisplayMode;
import org.lwjgl.opengl.GL11;
import org.lwjgl.opengl.Window;
import org.lwjgl.opengl.glu.Cylinder;
import org.lwjgl.opengl.glu.Disk;
import org.lwjgl.opengl.glu.GLU;
import org.lwjgl.opengl.glu.PartialDisk;
import org.lwjgl.opengl.glu.Sphere;
import org.lwjgl.input.Keyboard;

public class ParticleExplosion
{
	// VARIABLES
	private int numParticles, curParticles;
	private Particle particles[];
	
	public ParticleExplosion(int num)
	{
		numParticles = num;
		particles = new Particle[numParticles];
		curParticles = 0;
		
		for (int i=0; i < numParticles; i++)
		{
			particles[i] = new Particle("starship2d/Data/particle.png");
		}
	}
	
	public ParticleExplosion(float radius, int num, float decLife, float speed, float decSpeed, Vector2 pos,Vector2 size, Vector2 vel)
	{
		numParticles = num;
		particles = new Particle[numParticles];
		
		init(radius, decLife, speed, decSpeed, pos, size, vel);
	}
	
	public void init(float radius, float decLife, float speed, float decSpeed, Vector2 pos,Vector2 size, Vector2 vel)
	{
		curParticles = numParticles;
		
		for (int i=0; i < numParticles; i++)
		{
			generateParticle(radius, decLife, speed, decSpeed, pos, size, vel, i);
		}
	}
	
	// Return value of false means no more particles to render
	public boolean render()
	{
		int i = 0;
		while (i < curParticles)
		{
			if (!particles[i].render())
			{
				Particle p = particles[i];
				particles[i] = particles[curParticles-1];
				particles[curParticles-1] = p;
				curParticles--;
			}
			else
			{
				i++;
			}
		}
		
		return curParticles > 0;
	}

	private void generateParticle(float radius, float decLife, float speed,float decSpeed, Vector2 pos, Vector2 size, 
									Vector2 vel, int i)
	{
		Vector2 p, v;
		double angle;
		
		angle = Math.random() * 2*3.14f;
		p = new Vector2(Math.cos(angle) * radius, Math.sin(angle) * radius);
		v = new Vector2(p.x * speed + vel.x, p.y * speed + vel.y);
		p = new Vector2(p.x + pos.x, p.y + pos.y);
		
		particles[i].setPos(p);
		particles[i].setSize(size);
		particles[i].setVelocity(v);
		particles[i].setColor( new Vector3(0.6f,0.2f,0.6f));
		particles[i].setLife(1.0f);
		particles[i].setDecLife(decLife);
		particles[i].setDecSpeed(decSpeed);
		
	}
	
} // end ParticleExplosion
