//////////////////////////////////////////////////////////////////////////////////////
/*
Author: Henrik Krysell
E-mail: drx@drx.dk
Website: www.drx.dk

Copyright (C) 2004  Henrik Krysell

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
//////////////////////////////////////////////////////////////////////////////////////

/*
	FIXME!
	There are a lot of things to optimize in this class ex:

	* go through this class and look for optimaztions
*/

package starship2d;

import org.lwjgl.Display;
import org.lwjgl.DisplayMode;
import org.lwjgl.opengl.GL11;
import org.lwjgl.opengl.Window;
import org.lwjgl.opengl.glu.Cylinder;
import org.lwjgl.opengl.glu.Disk;
import org.lwjgl.opengl.glu.GLU;
import org.lwjgl.opengl.glu.PartialDisk;
import org.lwjgl.opengl.glu.Sphere;
import org.lwjgl.input.Keyboard;

public class ParticleRocket
{
	// VARIABLES
	private int numParticles;
	private Vector2 curVel = new Vector2(0,0);
	private Vector2 curPos = new Vector2(0,0);
	private Particle particles[];
	private float tailMul = 20.0f;
	private float tailAdd = 17.0f;
	private boolean regenerate = true;


	ParticleRocket()
	{
	}

	ParticleRocket(int nParticles, String path)
	{
		init(nParticles, path);
	}

	public void reInit()
	{
		regenerate = true;
		numParticles = particles.length;
		
		for (int i=0; i < numParticles; i++)
		{
			generateNewParticle(i);
			particles[i].setColor(new Vector3(0.6f,0.2f,0.6f));
			particles[i].setSize(new Vector2(10,10));
		}
	}
	
	public void init(int nParticles, String path)
	{
		numParticles = nParticles;

		particles = new Particle[numParticles];

		for (int i=0; i < numParticles; i++)
		{
			particles[i] = new Particle(path);
			generateNewParticle(i);
			particles[i].setColor(new Vector3(0.6f,0.2f,0.6f));
			particles[i].setSize(new Vector2(10,10));
		}
	}

	public void setCurVel(Vector2 vel)				{ curVel = new Vector2(-vel.x,-vel.y); }
	public void setCurPos(Vector2 p)				{ curPos = new Vector2(p.x,p.y); }
	public void setTailProp(float mul, float add)	{ tailMul = mul; tailAdd = add; }
	public void setRegenerate(boolean re)			{ regenerate = re; }
	
	// return value of false == no more particles
	public boolean render()
	{
		for (int i=0; i < numParticles; i++)
		{
			if (!particles[i].render())
			{
				if (regenerate)
					generateNewParticle(i);
				else
				{
					Particle p = particles[i];
					particles[i] = particles[numParticles-1];
					particles[numParticles-1] = p;
					
					numParticles--;
					// i should make a while loop instead of changing i here but im to lazy to rewrite it
					i--;
				}
			} // if
		} // for
		
		return numParticles > 0;
	}

	private void generateNewParticle(int i)
	{
		double angle = Math.random() * 2.0f;
		double c = Math.cos(angle);
		double s = Math.sin(angle);
		
		particles[i].setPos(curPos);
		particles[i].setVelocity(curVel);
		particles[i].setLife(1);
		particles[i].setDecLife((float) Math.random() * tailMul + tailAdd); // values of "* 10.0f + 1" creates a cool tail
	}

	// FUNCTIONS
} // end ParticleRocket
