//////////////////////////////////////////////////////////////////////////////////////
/*
Author: Henrik Krysell
E-mail: drx@drx.dk
Website: www.drx.dk

Copyright (C) 2004  Henrik Krysell

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
//////////////////////////////////////////////////////////////////////////////////////

package starship2d;


import org.lwjgl.Sys;


public class Timer
{
	public static float		frameInterval = 0;
	public static long		frameTime = 0;
	public static int		fps = 0;
	public static long		tmrRes;

	private static long		lastTime = 0;
	private static int		fpsCounter = 0;

	public static void init()
	{
		frameInterval = 0;
		frameTime = 0;
		fps = 0;
		lastTime = 0;
		fpsCounter = 0;
		
		Sys.setTime(0);
		tmrRes = Sys.getTimerResolution();
		System.out.println("Timer initlized, timer resolution: " + tmrRes);
	}
	
	public static void updateTimer()
	{
		long currentTime = Sys.getTime();
		
		frameInterval = ((float) (currentTime - frameTime)) / tmrRes;
		frameTime = currentTime;

		++fpsCounter;

		if( (currentTime - lastTime) > tmrRes )
		{
			lastTime = currentTime;
			
			fps = fpsCounter;
			fpsCounter = 0;
			
			//System.out.println(fps);
		}
	}
} // end Timer
